Index: trunk/NEMO/OPA_SRC/TRD/trdmod.F90
===================================================================
--- trunk/NEMO/OPA_SRC/TRD/trdmod.F90	(revision 485)
+++ trunk/NEMO/OPA_SRC/TRD/trdmod.F90	(revision 503)
@@ -434,4 +266,38 @@
 #   endif
 
+   SUBROUTINE trd_mod_init
+      !!----------------------------------------------------------------------
+      !!                  ***  ROUTINE trd_mod_init  ***
+      !! 
+      !! ** Purpose :   Initialization of activated trends
+      !!----------------------------------------------------------------------
+      USE in_out_manager          ! I/O manager
+
+      NAMELIST/namtrd/ ntrd, nctls, ln_trdmld_restart, ucf, ln_trdmld_instant
+      !!----------------------------------------------------------------------
+
+      IF( l_trdtra .OR. l_trddyn )   THEN
+         REWIND( numnam )
+         READ  ( numnam, namtrd )      ! namelist namtrd : trends diagnostic
+
+         IF(lwp) THEN
+            WRITE(numout,*)
+            WRITE(numout,*) ' trd_mod_init : Momentum/Tracers trends'
+            WRITE(numout,*) ' ~~~~~~~~~~~~~'
+            WRITE(numout,*) '       Namelist namtrd : set trends parameters'
+            WRITE(numout,*) '           * frequency of trends diagnostics   ntrd               = ', ntrd
+            WRITE(numout,*) '           * control surface type              nctls              = ', nctls
+            WRITE(numout,*) '           * restart for ML diagnostics        ln_trdmld_restart  = ', ln_trdmld_restart
+            WRITE(numout,*) '           * instantaneous or mean ML T/S      ln_trdmld_instant  = ', ln_trdmld_instant
+            WRITE(numout,*) '           * unit conversion factor            ucf                = ', ucf
+        ENDIF
+      ENDIF
+      !
+      IF( lk_trddyn .OR. lk_trdtra )    CALL trd_icp_init       ! integral constraints trends
+      IF( lk_trdmld                )    CALL trd_mld_init       ! mixed-layer trends (active  tracers)  
+      IF( lk_trdvor                )    CALL trd_vor_init       ! vorticity trends        
+      !
+   END SUBROUTINE trd_mod_init
+
    !!======================================================================
 END MODULE trdmod
Index: trunk/NEMO/OPA_SRC/TRD/trdmod_oce.F90
===================================================================
--- trunk/NEMO/OPA_SRC/TRD/trdmod_oce.F90	(revision 485)
+++ trunk/NEMO/OPA_SRC/TRD/trdmod_oce.F90	(revision 503)
@@ -4,19 +4,64 @@
    !! Ocean trends :   set tracer and momentum trend variables
    !!======================================================================
+   !! History :  9.0  !  04-08  (C. Talandier) Original code
    !!----------------------------------------------------------------------
-   !!  OPA 9.0 , LOCEAN-IPSL (2005) 
-   !! $Header$ 
-   !! This software is governed by the CeCILL licence see modipsl/doc/NEMO_CeCILL.txt 
-   !!----------------------------------------------------------------------
-   !! * Modules used
    USE trdicp_oce              ! ocean momentum/tracers bassin properties trends variables
    USE trdmld_oce              ! ocean active mixed layer tracers trends variables
    USE trdvor_oce              ! ocean vorticity trends variables
 
-   !! Control parameters
+   IMPLICIT NONE
+   PUBLIC
+
+   !!* Namelist namtrd:  diagnostics on dynamics/tracer trends
+   INTEGER , PUBLIC ::    ntrd  = 10                    !: time step frequency dynamics and tracers trends
+   INTEGER , PUBLIC ::    nctls =  0                    !: control surface type for trends vertical integration
+   REAL(wp), PUBLIC ::    ucf   = 1.                    !: unit conversion factor (for netCDF trends outputs)
+                                                        !: =1. (=86400.) for degC/s (degC/day) and psu/s (psu/day)
+   LOGICAL , PUBLIC ::    ln_trdmld_instant = .FALSE.   !: flag to diagnose inst./mean ML T/S trends
+   LOGICAL , PUBLIC ::    ln_trdmld_restart = .FALSE.   !: flag to restart mixed-layer diagnostics
+
+   !!* Control parameters
+# if defined key_trdtra   ||   defined key_trdmld
+   LOGICAL , PUBLIC ::   l_trdtra = .TRUE.              !: tracers  trend flag
+# else
+   LOGICAL , PUBLIC ::   l_trdtra = .FALSE.             !: tracers  trend flag
+# endif
+# if defined key_trddyn   ||   defined key_trdvor
+   LOGICAL , PUBLIC ::   l_trddyn = .TRUE.              !: momentum trend flag
+# else
+   LOGICAL , PUBLIC ::   l_trddyn = .FALSE.             !: momentum trend flag
+# endif
+
+   !!* Active tracers trends indexes
+   INTEGER, PUBLIC, PARAMETER ::   jptra_trd_xad =  1   !: x- horizontal advection
+   INTEGER, PUBLIC, PARAMETER ::   jptra_trd_yad =  2   !: y- horizontal advection
+   INTEGER, PUBLIC, PARAMETER ::   jptra_trd_zad =  3   !: z- vertical   advection
+   INTEGER, PUBLIC, PARAMETER ::   jptra_trd_ldf =  4   !: lateral       diffusion
+   INTEGER, PUBLIC, PARAMETER ::   jptra_trd_zdf =  5   !: vertical diffusion (Kz)
+   INTEGER, PUBLIC, PARAMETER ::   jptra_trd_bbc =  6   !: Bottom Boundary Condition (geoth. flux) 
+   INTEGER, PUBLIC, PARAMETER ::   jptra_trd_bbl =  7   !: Bottom Boundary Layer (diffusive/convective)
+   INTEGER, PUBLIC, PARAMETER ::   jptra_trd_npc =  8   !: static instability mixing
+   INTEGER, PUBLIC, PARAMETER ::   jptra_trd_dmp =  9   !: damping
+   INTEGER, PUBLIC, PARAMETER ::   jptra_trd_qsr = 10   !: penetrative solar radiation
+   INTEGER, PUBLIC, PARAMETER ::   jptra_trd_nsr = 11   !: non solar radiation
+   INTEGER, PUBLIC, PARAMETER ::   jptra_trd_atf = 12   !: Asselin correction
+   
+   !!* Momentum trends indexes
+   INTEGER, PUBLIC, PARAMETER ::   jpdyn_trd_hpg =  1   !: hydrostatic pressure gradient 
+   INTEGER, PUBLIC, PARAMETER ::   jpdyn_trd_keg =  2   !: kinetic energy gradient
+   INTEGER, PUBLIC, PARAMETER ::   jpdyn_trd_rvo =  3   !: relative vorticity
+   INTEGER, PUBLIC, PARAMETER ::   jpdyn_trd_pvo =  4   !: planetary vorticity
+   INTEGER, PUBLIC, PARAMETER ::   jpdyn_trd_ldf =  5   !: lateral diffusion
+   INTEGER, PUBLIC, PARAMETER ::   jpdyn_trd_zad =  6   !: vertical advection
+   INTEGER, PUBLIC, PARAMETER ::   jpdyn_trd_zdf =  7   !: vertical diffusion
+   INTEGER, PUBLIC, PARAMETER ::   jpdyn_trd_spg =  8   !: surface pressure gradient
+   INTEGER, PUBLIC, PARAMETER ::   jpdyn_trd_dat =  9   !: damping term
+   INTEGER, PUBLIC, PARAMETER ::   jpdyn_trd_swf = 10   !: surface wind forcing
+   INTEGER, PUBLIC, PARAMETER ::   jpdyn_trd_bfr = 11   !: bottom friction 
+
    !!----------------------------------------------------------------------
-   LOGICAL, PUBLIC ::   l_trdtra = .FALSE.    !: tracers  trend flag
-   LOGICAL, PUBLIC ::   l_trddyn = .FALSE.    !: momentum trend flag
-
-  !!======================================================================
+   !!  OPA 9.0 , LOCEAN-IPSL (2006) 
+   !! $Header$ 
+   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
+   !!======================================================================
 END MODULE trdmod_oce
Index: trunk/NEMO/OPA_SRC/TRD/trdvor.F90
===================================================================
--- trunk/NEMO/OPA_SRC/TRD/trdvor.F90	(revision 485)
+++ trunk/NEMO/OPA_SRC/TRD/trdvor.F90	(revision 503)
@@ -4,8 +4,11 @@
    !! Ocean diagnostics:  momentum trends
    !!=====================================================================
-   
+   !! History :  9.0  !  04-06  (L. Brunier, A-M. Treguier) Original code 
+   !!                 !  04-08  (C. Talandier) New trends organization
+   !!----------------------------------------------------------------------
 #if defined key_trdvor   ||   defined key_esopa
    !!----------------------------------------------------------------------
    !!   'key_trdvor'   : momentum trend diagnostics
+   !!----------------------------------------------------------------------
    !!----------------------------------------------------------------------
    !!   trd_vor      : momentum trends averaged over the depth
@@ -13,5 +16,4 @@
    !!   trd_vor_init : initialization step
    !!----------------------------------------------------------------------
-   !! * Modules used
    USE oce             ! ocean dynamics and tracers variables
    USE dom_oce         ! ocean space and time domain variables
@@ -27,22 +29,15 @@
    USE lbclnk          ! ocean lateral boundary conditions (or mpp link)
 
-
    IMPLICIT NONE
    PRIVATE
 
-   !! * Interfaces
    INTERFACE trd_vor_zint
       MODULE PROCEDURE trd_vor_zint_2d, trd_vor_zint_3d
    END INTERFACE
 
-   !! * Accessibility
-   PUBLIC trd_vor        ! routine called by step.F90
-   PUBLIC trd_vor_zint   ! routine called by dynamics routines
-   PUBLIC trd_vor_init   ! routine called by opa.F90
-
-   !! * Shared module variables
-   LOGICAL, PUBLIC ::   lk_trdvor = .TRUE.   ! momentum trend flag
-
-   !! * Module variables
+   PUBLIC   trd_vor        ! routine called by step.F90
+   PUBLIC   trd_vor_zint   ! routine called by dynamics routines
+   PUBLIC   trd_vor_init   ! routine called by opa.F90
+
    INTEGER ::                &
       nh_t, nmoydpvor  ,     &
@@ -61,7 +56,6 @@
      vor_avrres
 
-   REAL(wp), DIMENSION(jpi,jpj,jplvor)::   &  !: curl of trends
-      vortrd   
-
+   REAL(wp), DIMENSION(jpi,jpj,jpltot_vor)::   vortrd  !: curl of trends
+         
    CHARACTER(len=12) ::   cvort
 
@@ -70,9 +64,8 @@
 #  include "ldfdyn_substitute.h90"
 #  include "vectopt_loop_substitute.h90"
-
    !!----------------------------------------------------------------------
    !!   OPA 9.0 , LOCEAN-IPSL (2005) 
    !! $Header$ 
-   !! This software is governed by the CeCILL licence see modipsl/doc/NEMO_CeCILL.txt 
+   !! Software governed by the CeCILL licence (modipsl/doc/NEMO_CeCILL.txt)
    !!----------------------------------------------------------------------
   
@@ -80,4 +73,113 @@
 
    SUBROUTINE trd_vor_zint_2d( putrdvor, pvtrdvor, ktrd )
+      !!----------------------------------------------------------------------------
+      !!                  ***  ROUTINE trd_vor_zint  ***
+      !!
+      !! ** Purpose :   computation of vertically integrated vorticity budgets
+      !!      from ocean surface down to control surface (NetCDF output)
+      !!
+      !! ** Method/usage :
+      !!      integration done over nwrite-1 time steps
+      !!
+      !!
+      !! ** Action :
+      !!            /comvor/   :
+      !!                         vor_avr          average
+      !!                         vor_avrb         vorticity at kt-1
+      !!                         vor_avrbb        vorticity at begining of the NWRITE-1
+      !!                                          time steps averaging period
+      !!                         vor_avrbn         vorticity at time step after the
+      !!                                          begining of the NWRITE-1 time
+      !!                                          steps averaging period
+      !!
+      !!                 trends :
+      !!
+      !!                  vortrd (,, 1) = Pressure Gradient Trend
+      !!                  vortrd (,, 2) = KE Gradient Trend
+      !!                  vortrd (,, 3) = Relative Vorticity Trend
+      !!                  vortrd (,, 4) = Coriolis Term Trend
+      !!                  vortrd (,, 5) = Horizontal Diffusion Trend
+      !!                  vortrd (,, 6) = Vertical Advection Trend
+      !!                  vortrd (,, 7) = Vertical Diffusion Trend
+      !!                  vortrd (,, 8) = Surface Pressure Grad. Trend
+      !!                  vortrd (,, 9) = Beta V
+      !!                  vortrd (,,10) = forcing term
+      !!		  vortrd (,,11) = bottom friction term
+      !!                  rotot(,) : total cumulative trends over nwrite-1 time steps
+      !!                  vor_avrtot(,) : first membre of vrticity equation
+      !!                  vor_avrres(,) : residual = dh/dt entrainment
+      !!
+      !!      trends output in netCDF format using ioipsl
+      !!
+      !!----------------------------------------------------------------------
+      INTEGER, INTENT( in ) ::   ktrd         ! ocean trend index
+      REAL(wp), DIMENSION(jpi,jpj), INTENT( inout ) ::   &
+         putrdvor,                         &  ! u vorticity trend 
+         pvtrdvor                             ! v vorticity trend
+      !!
+      INTEGER ::   ji, jj
+      INTEGER ::   ikbu, ikbum1, ikbv, ikbvm1
+      REAL(wp), DIMENSION(jpi,jpj) ::   zudpvor, zvdpvor   ! total cmulative trends
+      !!----------------------------------------------------------------------
+
+      ! Initialization
+      zudpvor(:,:) = 0.e0
+      zvdpvor(:,:) = 0.e0
+
+      CALL lbc_lnk( putrdvor,  'U' , -1. )
+      CALL lbc_lnk( pvtrdvor,  'V' , -1. )
+
+      !  =====================================
+      !  I vertical integration of 2D trends
+      !  =====================================
+
+      SELECT CASE (ktrd) 
+
+      CASE (jpvor_bfr)        ! bottom friction
+
+         DO jj = 2, jpjm1
+            DO ji = fs_2, fs_jpim1 
+               ikbu   = min( mbathy(ji+1,jj), mbathy(ji,jj) )
+               ikbum1 = max( ikbu-1, 1 )
+               ikbv   = min( mbathy(ji,jj+1), mbathy(ji,jj) )
+               ikbvm1 = max( ikbv-1, 1 )
+            
+               zudpvor(ji,jj) = putrdvor(ji,jj) * fse3u(ji,jj,ikbum1) * e1u(ji,jj) * umask(ji,jj,ikbum1)
+               zvdpvor(ji,jj) = pvtrdvor(ji,jj) * fse3v(ji,jj,ikbvm1) * e2v(ji,jj) * vmask(ji,jj,ikbvm1)
+            END DO
+         END DO
+
+      CASE (jpvor_swf)        ! wind stress
+
+         zudpvor(:,:) = putrdvor(:,:) * fse3u(:,:,1) * e1u(:,:) * umask(:,:,1)
+         zvdpvor(:,:) = pvtrdvor(:,:) * fse3v(:,:,1) * e2v(:,:) * vmask(:,:,1)
+
+      END SELECT
+
+      ! Average except for Beta.V
+      zudpvor(:,:) = zudpvor(:,:) * hur(:,:)
+      zvdpvor(:,:) = zvdpvor(:,:) * hvr(:,:)
+   
+      ! Curl
+      DO ji=1,jpim1
+         DO jj=1,jpjm1
+            vortrd(ji,jj,ktrd) = ( zvdpvor(ji+1,jj) - zvdpvor(ji,jj)        &
+                 &                - ( zudpvor(ji,jj+1) - zudpvor(ji,jj) ) ) &
+                 &               / ( e1f(ji,jj) * e2f(ji,jj) )
+         END DO
+      END DO
+
+      ! Surface mask
+      vortrd(:,:,ktrd) = vortrd(:,:,ktrd) * fmask(:,:,1)
+
+      IF( idebug /= 0 ) THEN
+         IF(lwp) WRITE(numout,*) ' debuging trd_vor_zint: I done'
+         CALL FLUSH(numout)
+      ENDIF
+      !
+   END SUBROUTINE trd_vor_zint_2d
+
+
+   SUBROUTINE trd_vor_zint_3d( putrdvor, pvtrdvor, ktrd )
       !!----------------------------------------------------------------------------
       !!                  ***  ROUTINE trd_vor_zint  ***
@@ -119,136 +221,11 @@
       !!      trends output in netCDF format using ioipsl
       !!
-      !! History :
-      !!   9.0  !  04-06  (L. Brunier, A-M. Treguier) Original code 
-      !!        !  04-08  (C. Talandier) New trends organization
-      !!----------------------------------------------------------------------
-      !! * Arguments
+      !!----------------------------------------------------------------------
       INTEGER, INTENT( in ) ::   ktrd         ! ocean trend index
-
-      REAL(wp), DIMENSION(jpi,jpj), INTENT( inout ) ::   &
-         putrdvor,                         &  ! u vorticity trend 
-         pvtrdvor                             ! v vorticity trend
-
-      !! * Local declarations
-      INTEGER ::   ji, jj
-      INTEGER ::   ikbu, ikbum1, ikbv, ikbvm1
-      REAL(wp), DIMENSION(jpi,jpj) ::   &
-         zudpvor,                       &  ! total cmulative trends
-         zvdpvor                           !   "      "        "
-      !!----------------------------------------------------------------------
-
-      ! Initialization
-      zudpvor(:,:) = 0.e0
-      zvdpvor(:,:) = 0.e0
-
-      CALL lbc_lnk( putrdvor,  'U' , -1. )
-      CALL lbc_lnk( pvtrdvor,  'V' , -1. )
-
-      !  =====================================
-      !  I vertical integration of 2D trends
-      !  =====================================
-
-      SELECT CASE (ktrd) 
-
-      CASE (jpvorbfr)        ! bottom friction
-
-         DO jj = 2, jpjm1
-            DO ji = fs_2, fs_jpim1 
-               ikbu   = min( mbathy(ji+1,jj), mbathy(ji,jj) )
-               ikbum1 = max( ikbu-1, 1 )
-               ikbv   = min( mbathy(ji,jj+1), mbathy(ji,jj) )
-               ikbvm1 = max( ikbv-1, 1 )
-            
-               zudpvor(ji,jj) = putrdvor(ji,jj) * fse3u(ji,jj,ikbum1) * e1u(ji,jj) * umask(ji,jj,ikbum1)
-               zvdpvor(ji,jj) = pvtrdvor(ji,jj) * fse3v(ji,jj,ikbvm1) * e2v(ji,jj) * vmask(ji,jj,ikbvm1)
-            END DO
-         END DO
-
-      CASE (jpvorswf)        ! wind stress
-
-         zudpvor(:,:) = putrdvor(:,:) * fse3u(:,:,1) * e1u(:,:) * umask(:,:,1)
-         zvdpvor(:,:) = pvtrdvor(:,:) * fse3v(:,:,1) * e2v(:,:) * vmask(:,:,1)
-
-      END SELECT
-
-      ! Average except for Beta.V
-      zudpvor(:,:) = zudpvor(:,:) * hur(:,:)
-      zvdpvor(:,:) = zvdpvor(:,:) * hvr(:,:)
-   
-      ! Curl
-      DO ji=1,jpim1
-         DO jj=1,jpjm1
-            vortrd(ji,jj,ktrd) = ( zvdpvor(ji+1,jj) - zvdpvor(ji,jj)        &
-                 &                - ( zudpvor(ji,jj+1) - zudpvor(ji,jj) ) ) &
-                 &               / ( e1f(ji,jj) * e2f(ji,jj) )
-         END DO
-      END DO
-
-      ! Surface mask
-      vortrd(:,:,ktrd) = vortrd(:,:,ktrd) * fmask(:,:,1)
-
-      IF( idebug /= 0 ) THEN
-         IF(lwp) WRITE(numout,*) ' debuging trd_vor_zint: I done'
-         CALL FLUSH(numout)
-      ENDIF
-
-   END SUBROUTINE trd_vor_zint_2d
-
-
-
-   SUBROUTINE trd_vor_zint_3d( putrdvor, pvtrdvor, ktrd )
-      !!----------------------------------------------------------------------------
-      !!                  ***  ROUTINE trd_vor_zint  ***
-      !!
-      !! ** Purpose :   computation of vertically integrated vorticity budgets
-      !!      from ocean surface down to control surface (NetCDF output)
-      !!
-      !! ** Method/usage :
-      !!      integration done over nwrite-1 time steps
-      !!
-      !!
-      !! ** Action :
-      !!            /comvor/   :
-      !!                         vor_avr          average
-      !!                         vor_avrb         vorticity at kt-1
-      !!                         vor_avrbb        vorticity at begining of the NWRITE-1
-      !!                                          time steps averaging period
-      !!                         vor_avrbn         vorticity at time step after the
-      !!                                          begining of the NWRITE-1 time
-      !!                                          steps averaging period
-      !!
-      !!                 trends :
-      !!
-      !!                  vortrd (,,1) = Pressure Gradient Trend
-      !!                  vortrd (,,2) = KE Gradient Trend
-      !!                  vortrd (,,3) = Relative Vorticity Trend
-      !!                  vortrd (,,4) = Coriolis Term Trend
-      !!                  vortrd (,,5) = Horizontal Diffusion Trend
-      !!                  vortrd (,,6) = Vertical Advection Trend
-      !!                  vortrd (,,7) = Vertical Diffusion Trend
-      !!                  vortrd (,,8) = Surface Pressure Grad. Trend
-      !!                  vortrd (,,9) = Beta V
-      !!                  vortrd (,,10) = forcing term
-      !!		  vortrd (,,11) = bottom friction term
-      !!                  rotot(,) : total cumulative trends over nwrite-1 time steps
-      !!                  vor_avrtot(,) : first membre of vrticity equation
-      !!                  vor_avrres(,) : residual = dh/dt entrainment
-      !!
-      !!      trends output in netCDF format using ioipsl
-      !!
-      !! History :
-      !!   9.0  !  04-06  (L. Brunier, A-M. Treguier) Original code 
-      !!        !  04-08  (C. Talandier) New trends organization
-      !!----------------------------------------------------------------------
-      !! * Arguments
-      INTEGER, INTENT( in ) ::   ktrd         ! ocean trend index
-
       REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT( inout ) ::   &
          putrdvor,                         &  ! u vorticity trend 
          pvtrdvor                             ! v vorticity trend
-
-      !! * Local declarations
+      !!
       INTEGER ::   ji, jj, jk
-
       REAL(wp), DIMENSION(jpi,jpj) ::   &
          zubet,                         &  ! u Beta.V case
@@ -279,5 +256,5 @@
       ! Save Beta.V term to avoid average before Curl
       ! Beta.V : intergration, no average
-      IF( ktrd == jpvorbev ) THEN 
+      IF( ktrd == jpvor_bev ) THEN 
          zubet(:,:) = zudpvor(:,:)
          zvbet(:,:) = zvdpvor(:,:)
@@ -302,8 +279,8 @@
       ! Special treatement for the Beta.V term
       ! Compute the Curl of the Beta.V term which is not averaged
-      IF( ktrd == jpvorbev ) THEN
+      IF( ktrd == jpvor_bev ) THEN
          DO ji=1,jpim1
             DO jj=1,jpjm1
-               vortrd(ji,jj,jpvorbev) = (  zvbet(ji+1,jj) - zvbet(ji,jj) -   &
+               vortrd(ji,jj,jpvor_bev) = (  zvbet(ji+1,jj) - zvbet(ji,jj) -   &
                     &                    ( zubet(ji,jj+1) - zubet(ji,jj) ) ) &
                     &                   / ( e1f(ji,jj) * e2f(ji,jj) )
@@ -312,8 +289,8 @@
 
          ! Average on the Curl
-         vortrd(:,:,jpvorbev) = vortrd(:,:,jpvorbev) * hur(:,:)
+         vortrd(:,:,jpvor_bev) = vortrd(:,:,jpvor_bev) * hur(:,:)
 
          ! Surface mask
-         vortrd(:,:,jpvorbev) = vortrd(:,:,jpvorbev) * fmask(:,:,1)
+         vortrd(:,:,jpvor_bev) = vortrd(:,:,jpvor_bev) * fmask(:,:,1)
       ENDIF
    
@@ -322,7 +299,6 @@
          CALL FLUSH(numout)
       ENDIF
-
+      !
    END SUBROUTINE trd_vor_zint_3d
-
 
 
@@ -333,21 +309,10 @@
       !! ** Purpose :  computation of cumulated trends over analysis period
       !!               and make outputs (NetCDF or DIMG format)
-      !!
-      !! ** Method/usage :
-      !!
-      !! History :
-      !!   9.0  !  04-06  (L. Brunier, A-M. Treguier) Original code 
-      !!        !  04-08  (C. Talandier) New trends organization
-      !!----------------------------------------------------------------------
-      !! * Arguments
+      !!----------------------------------------------------------------------
       INTEGER, INTENT( in ) ::   kt   ! ocean time-step index
-
-      !! * Local declarations
-      INTEGER :: ji, jj, jk, jl, it
-
-      REAL(wp) :: zmean
-
-      REAL(wp) ,DIMENSION(jpi,jpj) ::   &
-         zun, zvn
+      !!
+      INTEGER  ::   ji, jj, jk, jl, it
+      REAL(wp) ::   zmean
+      REAL(wp), DIMENSION(jpi,jpj) ::   zun, zvn
       !!----------------------------------------------------------------------
 
@@ -424,5 +389,5 @@
       IF( kt >= nit000+2 ) THEN
          nmoydpvor = nmoydpvor + 1
-         DO jl = 1, jplvor
+         DO jl = 1, jpltot_vor
             IF( jl /= 9 ) THEN
                rotot(:,:) = rotot(:,:) + vortrd(:,:,jl)
@@ -490,34 +455,35 @@
          it= kt-nit000+1
          IF( lwp .AND. MOD( kt, ntrd ) == 0 ) THEN
-            WRITE(numout,*) '     trdvor_ncwrite : write NetCDF fields'
+            WRITE(numout,*) ''
+            WRITE(numout,*) 'trd_vor : write trends in the NetCDF file at kt = ', kt
+            WRITE(numout,*) '~~~~~~~  '
          ENDIF
  
-         CALL histwrite( nidvor,"sovortPh",it,vortrd(:,:,1),ndimvor1,ndexvor1)  ! grad Ph
-         CALL histwrite( nidvor,"sovortEk",it,vortrd(:,:,2),ndimvor1,ndexvor1)  ! Energy
-         CALL histwrite( nidvor,"sovozeta",it,vortrd(:,:,3),ndimvor1,ndexvor1)  ! rel vorticity
-         CALL histwrite( nidvor,"sovortif",it,vortrd(:,:,4),ndimvor1,ndexvor1)  ! coriolis
-         CALL histwrite( nidvor,"sovodifl",it,vortrd(:,:,5),ndimvor1,ndexvor1)  ! lat diff
-         CALL histwrite( nidvor,"sovoadvv",it,vortrd(:,:,6),ndimvor1,ndexvor1)  ! vert adv
-         CALL histwrite( nidvor,"sovodifv",it,vortrd(:,:,7),ndimvor1,ndexvor1)  ! vert diff
-         CALL histwrite( nidvor,"sovortPs",it,vortrd(:,:,8),ndimvor1,ndexvor1)  ! grad Ps
-         CALL histwrite( nidvor,"sovortbv",it,vortrd(:,:,9),ndimvor1,ndexvor1)  ! beta.V
-         CALL histwrite( nidvor,"sovowind",it,vortrd(:,:,10),ndimvor1,ndexvor1) ! wind stress
-         CALL histwrite( nidvor,"sovobfri",it,vortrd(:,:,11),ndimvor1,ndexvor1) ! bottom friction
+         CALL histwrite( nidvor,"sovortPh",it,vortrd(:,:,jpvor_prg),ndimvor1,ndexvor1)  ! grad Ph
+         CALL histwrite( nidvor,"sovortEk",it,vortrd(:,:,jpvor_keg),ndimvor1,ndexvor1)  ! Energy
+         CALL histwrite( nidvor,"sovozeta",it,vortrd(:,:,jpvor_rvo),ndimvor1,ndexvor1)  ! rel vorticity
+         CALL histwrite( nidvor,"sovortif",it,vortrd(:,:,jpvor_pvo),ndimvor1,ndexvor1)  ! coriolis
+         CALL histwrite( nidvor,"sovodifl",it,vortrd(:,:,jpvor_ldf),ndimvor1,ndexvor1)  ! lat diff
+         CALL histwrite( nidvor,"sovoadvv",it,vortrd(:,:,jpvor_zad),ndimvor1,ndexvor1)  ! vert adv
+         CALL histwrite( nidvor,"sovodifv",it,vortrd(:,:,jpvor_zdf),ndimvor1,ndexvor1)  ! vert diff
+         CALL histwrite( nidvor,"sovortPs",it,vortrd(:,:,jpvor_spg),ndimvor1,ndexvor1)  ! grad Ps
+         CALL histwrite( nidvor,"sovortbv",it,vortrd(:,:,jpvor_bev),ndimvor1,ndexvor1)  ! beta.V
+         CALL histwrite( nidvor,"sovowind",it,vortrd(:,:,jpvor_swf),ndimvor1,ndexvor1) ! wind stress
+         CALL histwrite( nidvor,"sovobfri",it,vortrd(:,:,jpvor_bfr),ndimvor1,ndexvor1) ! bottom friction
          CALL histwrite( nidvor,"1st_mbre",it,vor_avrtot    ,ndimvor1,ndexvor1) ! First membre
          CALL histwrite( nidvor,"sovorgap",it,vor_avrres    ,ndimvor1,ndexvor1) ! gap between 1st and 2 nd mbre
-
+         !
          IF( idebug /= 0 ) THEN
             WRITE(numout,*) ' debuging trd_vor: III.4 done'
             CALL FLUSH(numout)
          ENDIF
-
-      ENDIF
-
+         !
+      ENDIF
+      !
       IF( MOD( kt - nit000+1, ntrd ) == 0 ) rotot(:,:)=0
-
+      !
       IF( kt == nitend )   CALL histclo( nidvor )
-
+      !
    END SUBROUTINE trd_vor
-
 
 
@@ -528,18 +494,8 @@
       !! ** Purpose :   computation of vertically integrated T and S budgets
       !!      from ocean surface down to control surface (NetCDF output)
-      !!
-      !! ** Method/usage :
-      !!
-      !! History :
-      !!   9.0  !  04-06  (L. Brunier, A-M. Treguier) Original code 
-      !!        !  04-08  (C. Talandier) New trends organization
-      !!----------------------------------------------------------------------
-      !! * Local declarations
-      REAL(wp) :: zjulian, zsto, zout
-
+      !!----------------------------------------------------------------------
+      REAL(wp) ::   zjulian, zsto, zout
       CHARACTER (len=40) ::   clhstnam
       CHARACTER (len=40) ::   clop
-
-      NAMELIST/namtrd/ ntrd,nctls
       !!----------------------------------------------------------------------
 
@@ -553,20 +509,13 @@
       idebug = 0      ! set it to 1 in case of problem to have more Print
 
-      ! namelist namtrd : trend diagnostic
-      REWIND( numnam )
-      READ  ( numnam, namtrd )
-
       IF(lwp) THEN
          WRITE(numout,*) ' '
-         WRITE(numout,*) 'trd_vor_init: vorticity trends'
-         WRITE(numout,*) '~~~~~~~~~~~~~'
+         WRITE(numout,*) ' trd_vor_init: vorticity trends'
+         WRITE(numout,*) ' ~~~~~~~~~~~~'
          WRITE(numout,*) ' '
-         WRITE(numout,*) '          Namelist namtrd : '
-         WRITE(numout,*) '             time step frequency trend       ntrd  = ',ntrd
-         WRITE(numout,*) ' '
-         WRITE(numout,*) '##########################################################################'
-         WRITE(numout,*) ' CAUTION: The interpretation of the vorticity trends is'
-         WRITE(numout,*) ' not obvious, please contact Anne-Marie TREGUIER at: treguier@ifremer.fr '
-         WRITE(numout,*) '##########################################################################'
+         WRITE(numout,*) '               ##########################################################################'
+         WRITE(numout,*) '                CAUTION: The interpretation of the vorticity trends is'
+         WRITE(numout,*) '                not obvious, please contact Anne-Marie TREGUIER at: treguier@ifremer.fr '
+         WRITE(numout,*) '               ##########################################################################'
          WRITE(numout,*) ' '
       ENDIF
@@ -599,13 +548,13 @@
       zout = ntrd*rdt
 
-      IF(lwp) WRITE (numout,*) ' trdvor_ncinit: netCDF initialization'
+      IF(lwp) WRITE(numout,*) '               netCDF initialization'
 
       ! II.2 Compute julian date from starting date of the run
       ! ------------------------
       CALL ymds2ju( nyear, nmonth, nday, 0.e0, zjulian )
-      IF (lwp) WRITE(numout,*)' '  
-      IF (lwp) WRITE(numout,*)' Date 0 used :',nit000         &
-           ,' YEAR ', nyear,' MONTH ', nmonth,' DAY ', nday   &
-           ,'Julian day : ', zjulian
+      IF(lwp) WRITE(numout,*)' '  
+      IF(lwp) WRITE(numout,*)'               Date 0 used :',nit000,    &
+         &                   ' YEAR ', nyear,' MONTH '      , nmonth,   &
+         &                   ' DAY ' , nday, 'Julian day : ', zjulian
 
       ! II.3 Define the T grid trend file (nidvor)
@@ -650,5 +599,5 @@
          CALL FLUSH(numout)
       ENDIF
-
+      !
    END SUBROUTINE trd_vor_init
 
@@ -657,11 +606,7 @@
    !!   Default option :                                       Empty module
    !!----------------------------------------------------------------------
-   LOGICAL, PUBLIC ::   lk_trdvor = .FALSE.   ! momentum trend flag
-
-   !! * Interfaces
    INTERFACE trd_vor_zint
       MODULE PROCEDURE trd_vor_zint_2d, trd_vor_zint_3d
    END INTERFACE
-
 CONTAINS
    SUBROUTINE trd_vor( kt )        ! Empty routine
@@ -669,6 +614,5 @@
    END SUBROUTINE trd_vor
    SUBROUTINE trd_vor_zint_2d( putrdvor, pvtrdvor, ktrd )
-      REAL, DIMENSION(:,:), INTENT( inout ) ::   &
-         putrdvor, pvtrdvor                  ! U and V momentum trends
+      REAL, DIMENSION(:,:), INTENT( inout ) ::   putrdvor, pvtrdvor
       INTEGER, INTENT( in ) ::   ktrd         ! ocean trend index
       WRITE(*,*) 'trd_vor_zint_2d: You should not have seen this print! error?', putrdvor(1,1)
@@ -677,6 +621,5 @@
    END SUBROUTINE trd_vor_zint_2d
    SUBROUTINE trd_vor_zint_3d( putrdvor, pvtrdvor, ktrd )
-      REAL, DIMENSION(:,:,:), INTENT( inout ) ::   &
-         putrdvor, pvtrdvor                  ! U and V momentum trends
+      REAL, DIMENSION(:,:,:), INTENT( inout ) ::   putrdvor, pvtrdvor
       INTEGER, INTENT( in ) ::   ktrd         ! ocean trend index
       WRITE(*,*) 'trd_vor_zint_3d: You should not have seen this print! error?', putrdvor(1,1,1)
